/* xnoise-pl-item.c generated by valac 0.11.7, the Vala compiler
 * generated from xnoise-pl-item.vala, do not modify */

/* pl-item.vala
 *
 * Copyright (C) 2010  Jörn Magens
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jörn Magens <shuerhaaken@googlemail.com>
 */
/* an instance of this Item object represents one entry in the list. An entry contains one or more data fields, at least the uri to the target*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define XNOISE_PL_TYPE_ITEM (xnoise_pl_item_get_type ())
#define XNOISE_PL_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_PL_TYPE_ITEM, XnoisePlItem))
#define XNOISE_PL_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_PL_TYPE_ITEM, XnoisePlItemClass))
#define XNOISE_PL_IS_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_PL_TYPE_ITEM))
#define XNOISE_PL_IS_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_PL_TYPE_ITEM))
#define XNOISE_PL_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_PL_TYPE_ITEM, XnoisePlItemClass))

typedef struct _XnoisePlItem XnoisePlItem;
typedef struct _XnoisePlItemClass XnoisePlItemClass;
typedef struct _XnoisePlItemPrivate XnoisePlItemPrivate;

#define XNOISE_PL_ITEM_TYPE_FIELD (xnoise_pl_item_field_get_type ())

#define XNOISE_PL_TYPE_TARGET_TYPE (xnoise_pl_target_type_get_type ())
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _XnoisePlParamSpecItem XnoisePlParamSpecItem;

struct _XnoisePlItem {
	GTypeInstance parent_instance;
	volatile int ref_count;
	XnoisePlItemPrivate * priv;
};

struct _XnoisePlItemClass {
	GTypeClass parent_class;
	void (*finalize) (XnoisePlItem *self);
};

typedef enum  {
	XNOISE_PL_ITEM_FIELD_URI = 0,
	XNOISE_PL_ITEM_FIELD_TITLE,
	XNOISE_PL_ITEM_FIELD_AUTHOR,
	XNOISE_PL_ITEM_FIELD_GENRE,
	XNOISE_PL_ITEM_FIELD_ALBUM,
	XNOISE_PL_ITEM_FIELD_COPYRIGHT,
	XNOISE_PL_ITEM_FIELD_DURATION,
	XNOISE_PL_ITEM_FIELD_PARAM_NAME,
	XNOISE_PL_ITEM_FIELD_PARAM_VALUE,
	XNOISE_PL_ITEM_FIELD_IS_REMOTE,
	XNOISE_PL_ITEM_FIELD_IS_PLAYLIST
} XnoisePlItemField;

typedef enum  {
	XNOISE_PL_TARGET_TYPE_URI,
	XNOISE_PL_TARGET_TYPE_REL_PATH,
	XNOISE_PL_TARGET_TYPE_ABS_PATH
} XnoisePlTargetType;

struct _XnoisePlItemPrivate {
	GHashTable* htable;
	XnoisePlTargetType _target_type;
	gchar* _base_path;
};

struct _XnoisePlParamSpecItem {
	GParamSpec parent_instance;
};


static gpointer xnoise_pl_item_parent_class = NULL;

gpointer xnoise_pl_item_ref (gpointer instance);
void xnoise_pl_item_unref (gpointer instance);
GParamSpec* xnoise_pl_param_spec_item (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void xnoise_pl_value_set_item (GValue* value, gpointer v_object);
void xnoise_pl_value_take_item (GValue* value, gpointer v_object);
gpointer xnoise_pl_value_get_item (const GValue* value);
GType xnoise_pl_item_get_type (void) G_GNUC_CONST;
GType xnoise_pl_item_field_get_type (void) G_GNUC_CONST;
GType xnoise_pl_target_type_get_type (void) G_GNUC_CONST;
#define XNOISE_PL_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), XNOISE_PL_TYPE_ITEM, XnoisePlItemPrivate))
enum  {
	XNOISE_PL_ITEM_DUMMY_PROPERTY
};
XnoisePlItem* xnoise_pl_item_new (void);
XnoisePlItem* xnoise_pl_item_construct (GType object_type);
static void _g_free0_ (gpointer var);
void xnoise_pl_item_add_field (XnoisePlItem* self, XnoisePlItemField field, const gchar* val);
XnoisePlItemField* xnoise_pl_item_get_contained_fields (XnoisePlItem* self, int* result_length1);
static void _vala_array_add1 (XnoisePlItemField** array, int* length, int* size, XnoisePlItemField value);
gchar* xnoise_pl_item_get_field (XnoisePlItem* self, XnoisePlItemField field);
gchar* xnoise_pl_item_get_uri (XnoisePlItem* self);
gchar* xnoise_pl_item_get_rel_path (XnoisePlItem* self);
const gchar* xnoise_pl_item_get_base_path (XnoisePlItem* self);
gchar* xnoise_pl_item_get_abs_path (XnoisePlItem* self);
static gboolean _vala_string_array_contains (const gchar** stack, int stack_length, const gchar* needle);
gchar* xnoise_pl_item_get_title (XnoisePlItem* self);
gchar* xnoise_pl_item_get_author (XnoisePlItem* self);
gchar* xnoise_pl_item_get_genre (XnoisePlItem* self);
gchar* xnoise_pl_item_get_album (XnoisePlItem* self);
gchar* xnoise_pl_item_get_copyright (XnoisePlItem* self);
gchar* xnoise_pl_item_get_duration_string (XnoisePlItem* self);
gchar* xnoise_pl_item_get_param_name (XnoisePlItem* self);
gchar* xnoise_pl_item_get_param_value (XnoisePlItem* self);
glong xnoise_pl_item_get_duration (XnoisePlItem* self);
glong xnoise_pl_get_duration_from_string (gchar** duration_string);
gboolean xnoise_pl_item_is_remote (XnoisePlItem* self);
gboolean xnoise_pl_item_is_playlist (XnoisePlItem* self);
XnoisePlTargetType xnoise_pl_item_get_target_type (XnoisePlItem* self);
void xnoise_pl_item_set_target_type (XnoisePlItem* self, XnoisePlTargetType value);
void xnoise_pl_item_set_base_path (XnoisePlItem* self, const gchar* value);
static void xnoise_pl_item_finalize (XnoisePlItem* obj);

extern const gchar* XNOISE_PL_remote_schemes[2];

GType xnoise_pl_item_field_get_type (void) {
	static volatile gsize xnoise_pl_item_field_type_id__volatile = 0;
	if (g_once_init_enter (&xnoise_pl_item_field_type_id__volatile)) {
		static const GEnumValue values[] = {{XNOISE_PL_ITEM_FIELD_URI, "XNOISE_PL_ITEM_FIELD_URI", "uri"}, {XNOISE_PL_ITEM_FIELD_TITLE, "XNOISE_PL_ITEM_FIELD_TITLE", "title"}, {XNOISE_PL_ITEM_FIELD_AUTHOR, "XNOISE_PL_ITEM_FIELD_AUTHOR", "author"}, {XNOISE_PL_ITEM_FIELD_GENRE, "XNOISE_PL_ITEM_FIELD_GENRE", "genre"}, {XNOISE_PL_ITEM_FIELD_ALBUM, "XNOISE_PL_ITEM_FIELD_ALBUM", "album"}, {XNOISE_PL_ITEM_FIELD_COPYRIGHT, "XNOISE_PL_ITEM_FIELD_COPYRIGHT", "copyright"}, {XNOISE_PL_ITEM_FIELD_DURATION, "XNOISE_PL_ITEM_FIELD_DURATION", "duration"}, {XNOISE_PL_ITEM_FIELD_PARAM_NAME, "XNOISE_PL_ITEM_FIELD_PARAM_NAME", "param-name"}, {XNOISE_PL_ITEM_FIELD_PARAM_VALUE, "XNOISE_PL_ITEM_FIELD_PARAM_VALUE", "param-value"}, {XNOISE_PL_ITEM_FIELD_IS_REMOTE, "XNOISE_PL_ITEM_FIELD_IS_REMOTE", "is-remote"}, {XNOISE_PL_ITEM_FIELD_IS_PLAYLIST, "XNOISE_PL_ITEM_FIELD_IS_PLAYLIST", "is-playlist"}, {0, NULL, NULL}};
		GType xnoise_pl_item_field_type_id;
		xnoise_pl_item_field_type_id = g_enum_register_static ("XnoisePlItemField", values);
		g_once_init_leave (&xnoise_pl_item_field_type_id__volatile, xnoise_pl_item_field_type_id);
	}
	return xnoise_pl_item_field_type_id__volatile;
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


XnoisePlItem* xnoise_pl_item_construct (GType object_type) {
	XnoisePlItem* self = NULL;
	GHashTable* _tmp0_ = NULL;
	self = (XnoisePlItem*) g_type_create_instance (object_type);
	_tmp0_ = g_hash_table_new_full (g_direct_hash, g_direct_equal, NULL, _g_free0_);
	_g_hash_table_unref0 (self->priv->htable);
	self->priv->htable = _tmp0_;
	return self;
}


XnoisePlItem* xnoise_pl_item_new (void) {
	return xnoise_pl_item_construct (XNOISE_PL_TYPE_ITEM);
}


void xnoise_pl_item_add_field (XnoisePlItem* self, XnoisePlItemField field, const gchar* val) {
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (val != NULL);
	_tmp0_ = g_strdup (val);
	g_hash_table_insert (self->priv->htable, GINT_TO_POINTER (field), _tmp0_);
}


static void _vala_array_add1 (XnoisePlItemField** array, int* length, int* size, XnoisePlItemField value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoisePlItemField, *array, *size);
	}
	(*array)[(*length)++] = value;
}


XnoisePlItemField* xnoise_pl_item_get_contained_fields (XnoisePlItem* self, int* result_length1) {
	XnoisePlItemField* result = NULL;
	XnoisePlItemField* _tmp0_ = NULL;
	XnoisePlItemField* retval;
	gint retval_length1;
	gint _retval_size_;
	GList* _tmp1_ = NULL;
	GList* list;
	XnoisePlItemField* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_new0 (XnoisePlItemField, 0);
	retval = _tmp0_;
	retval_length1 = 0;
	_retval_size_ = 0;
	_tmp1_ = g_hash_table_get_keys (self->priv->htable);
	list = _tmp1_;
	if (list == NULL) {
		XnoisePlItemField* _tmp2_;
		_tmp2_ = retval;
		*result_length1 = retval_length1;
		result = _tmp2_;
		_g_list_free0 (list);
		return result;
	}
	{
		GList* f_collection;
		GList* f_it;
		f_collection = list;
		for (f_it = f_collection; f_it != NULL; f_it = f_it->next) {
			XnoisePlItemField f;
			f = GPOINTER_TO_INT (f_it->data);
			{
				_vala_array_add1 (&retval, &retval_length1, &_retval_size_, f);
			}
		}
	}
	_tmp3_ = retval;
	*result_length1 = retval_length1;
	result = _tmp3_;
	_g_list_free0 (list);
	return result;
}


gchar* xnoise_pl_item_get_field (XnoisePlItem* self, XnoisePlItemField field) {
	gchar* result = NULL;
	gconstpointer _tmp0_ = NULL;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (field));
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
	result = _tmp1_;
	return result;
}


gchar* xnoise_pl_item_get_uri (XnoisePlItem* self) {
	gchar* result = NULL;
	gconstpointer _tmp0_ = NULL;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (XNOISE_PL_ITEM_FIELD_URI));
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
	result = _tmp1_;
	return result;
}


gchar* xnoise_pl_item_get_rel_path (XnoisePlItem* self) {
	gchar* result = NULL;
	gconstpointer _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* s;
	GFile* _tmp2_ = NULL;
	GFile* f;
	GFile* _tmp3_ = NULL;
	GFile* bp;
	gchar* _tmp4_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (XNOISE_PL_ITEM_FIELD_URI));
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
	s = _tmp1_;
	if (s == NULL) {
		result = NULL;
		_g_free0 (s);
		return result;
	}
	_tmp2_ = g_file_new_for_uri (s);
	f = _tmp2_;
	if (self->priv->_base_path == NULL) {
		result = NULL;
		_g_object_unref0 (f);
		_g_free0 (s);
		return result;
	}
	_tmp3_ = g_file_new_for_path (self->priv->_base_path);
	bp = _tmp3_;
	if (bp == NULL) {
		result = NULL;
		_g_object_unref0 (bp);
		_g_object_unref0 (f);
		_g_free0 (s);
		return result;
	}
	_tmp4_ = g_file_get_relative_path (bp, f);
	result = _tmp4_;
	_g_object_unref0 (bp);
	_g_object_unref0 (f);
	_g_free0 (s);
	return result;
}


static gboolean _vala_string_array_contains (const gchar** stack, int stack_length, const gchar* needle) {
	int i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}


gchar* xnoise_pl_item_get_abs_path (XnoisePlItem* self) {
	gchar* result = NULL;
	gconstpointer _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* s;
	GFile* _tmp2_ = NULL;
	GFile* f;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	gboolean _tmp5_;
	gchar* _tmp6_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (XNOISE_PL_ITEM_FIELD_URI));
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
	s = _tmp1_;
	if (s == NULL) {
		result = NULL;
		_g_free0 (s);
		return result;
	}
	_tmp2_ = g_file_new_for_uri (s);
	f = _tmp2_;
	_tmp3_ = g_file_get_uri_scheme (f);
	_tmp4_ = _tmp3_;
	_tmp5_ = _vala_string_array_contains (XNOISE_PL_remote_schemes, G_N_ELEMENTS (XNOISE_PL_remote_schemes), _tmp4_);
	_g_free0 (_tmp4_);
	if (_tmp5_) {
		result = NULL;
		_g_object_unref0 (f);
		_g_free0 (s);
		return result;
	}
	_tmp6_ = g_file_get_path (f);
	result = _tmp6_;
	_g_object_unref0 (f);
	_g_free0 (s);
	return result;
}


gchar* xnoise_pl_item_get_title (XnoisePlItem* self) {
	gchar* result = NULL;
	gconstpointer _tmp0_ = NULL;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (XNOISE_PL_ITEM_FIELD_TITLE));
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
	result = _tmp1_;
	return result;
}


gchar* xnoise_pl_item_get_author (XnoisePlItem* self) {
	gchar* result = NULL;
	gconstpointer _tmp0_ = NULL;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (XNOISE_PL_ITEM_FIELD_AUTHOR));
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
	result = _tmp1_;
	return result;
}


gchar* xnoise_pl_item_get_genre (XnoisePlItem* self) {
	gchar* result = NULL;
	gconstpointer _tmp0_ = NULL;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (XNOISE_PL_ITEM_FIELD_GENRE));
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
	result = _tmp1_;
	return result;
}


gchar* xnoise_pl_item_get_album (XnoisePlItem* self) {
	gchar* result = NULL;
	gconstpointer _tmp0_ = NULL;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (XNOISE_PL_ITEM_FIELD_ALBUM));
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
	result = _tmp1_;
	return result;
}


gchar* xnoise_pl_item_get_copyright (XnoisePlItem* self) {
	gchar* result = NULL;
	gconstpointer _tmp0_ = NULL;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (XNOISE_PL_ITEM_FIELD_COPYRIGHT));
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
	result = _tmp1_;
	return result;
}


gchar* xnoise_pl_item_get_duration_string (XnoisePlItem* self) {
	gchar* result = NULL;
	gconstpointer _tmp0_ = NULL;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (XNOISE_PL_ITEM_FIELD_DURATION));
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
	result = _tmp1_;
	return result;
}


gchar* xnoise_pl_item_get_param_name (XnoisePlItem* self) {
	gchar* result = NULL;
	gconstpointer _tmp0_ = NULL;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (XNOISE_PL_ITEM_FIELD_PARAM_NAME));
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
	result = _tmp1_;
	return result;
}


gchar* xnoise_pl_item_get_param_value (XnoisePlItem* self) {
	gchar* result = NULL;
	gconstpointer _tmp0_ = NULL;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (XNOISE_PL_ITEM_FIELD_PARAM_VALUE));
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
	result = _tmp1_;
	return result;
}


glong xnoise_pl_item_get_duration (XnoisePlItem* self) {
	glong result = 0L;
	gconstpointer _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* s;
	glong _tmp2_;
	g_return_val_if_fail (self != NULL, 0L);
	_tmp0_ = g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (XNOISE_PL_ITEM_FIELD_DURATION));
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
	s = _tmp1_;
	if (s == NULL) {
		result = (glong) (-1);
		_g_free0 (s);
		return result;
	}
	_tmp2_ = xnoise_pl_get_duration_from_string (&s);
	result = _tmp2_;
	_g_free0 (s);
	return result;
}


gboolean xnoise_pl_item_is_remote (XnoisePlItem* self) {
	gboolean result = FALSE;
	gconstpointer _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* s;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (XNOISE_PL_ITEM_FIELD_IS_REMOTE));
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
	s = _tmp1_;
	if (g_strcmp0 (s, "1") == 0) {
		result = TRUE;
		_g_free0 (s);
		return result;
	}
	result = FALSE;
	_g_free0 (s);
	return result;
}


gboolean xnoise_pl_item_is_playlist (XnoisePlItem* self) {
	gboolean result = FALSE;
	gconstpointer _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* s;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_hash_table_lookup (self->priv->htable, GINT_TO_POINTER (XNOISE_PL_ITEM_FIELD_IS_PLAYLIST));
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
	s = _tmp1_;
	if (g_strcmp0 (s, "1") == 0) {
		result = TRUE;
		_g_free0 (s);
		return result;
	}
	result = FALSE;
	_g_free0 (s);
	return result;
}


XnoisePlTargetType xnoise_pl_item_get_target_type (XnoisePlItem* self) {
	XnoisePlTargetType result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_target_type;
	return result;
}


void xnoise_pl_item_set_target_type (XnoisePlItem* self, XnoisePlTargetType value) {
	g_return_if_fail (self != NULL);
	self->priv->_target_type = value;
}


const gchar* xnoise_pl_item_get_base_path (XnoisePlItem* self) {
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_base_path;
	return result;
}


void xnoise_pl_item_set_base_path (XnoisePlItem* self, const gchar* value) {
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_base_path);
	self->priv->_base_path = _tmp0_;
}


static void xnoise_pl_value_item_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void xnoise_pl_value_item_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		xnoise_pl_item_unref (value->data[0].v_pointer);
	}
}


static void xnoise_pl_value_item_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = xnoise_pl_item_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer xnoise_pl_value_item_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* xnoise_pl_value_item_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		XnoisePlItem* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = xnoise_pl_item_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* xnoise_pl_value_item_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	XnoisePlItem** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = xnoise_pl_item_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* xnoise_pl_param_spec_item (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	XnoisePlParamSpecItem* spec;
	g_return_val_if_fail (g_type_is_a (object_type, XNOISE_PL_TYPE_ITEM), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer xnoise_pl_value_get_item (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, XNOISE_PL_TYPE_ITEM), NULL);
	return value->data[0].v_pointer;
}


void xnoise_pl_value_set_item (GValue* value, gpointer v_object) {
	XnoisePlItem* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, XNOISE_PL_TYPE_ITEM));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, XNOISE_PL_TYPE_ITEM));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		xnoise_pl_item_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		xnoise_pl_item_unref (old);
	}
}


void xnoise_pl_value_take_item (GValue* value, gpointer v_object) {
	XnoisePlItem* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, XNOISE_PL_TYPE_ITEM));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, XNOISE_PL_TYPE_ITEM));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		xnoise_pl_item_unref (old);
	}
}


static void xnoise_pl_item_class_init (XnoisePlItemClass * klass) {
	xnoise_pl_item_parent_class = g_type_class_peek_parent (klass);
	XNOISE_PL_ITEM_CLASS (klass)->finalize = xnoise_pl_item_finalize;
	g_type_class_add_private (klass, sizeof (XnoisePlItemPrivate));
}


static void xnoise_pl_item_instance_init (XnoisePlItem * self) {
	self->priv = XNOISE_PL_ITEM_GET_PRIVATE (self);
	self->priv->htable = NULL;
	self->priv->_target_type = XNOISE_PL_TARGET_TYPE_URI;
	self->priv->_base_path = NULL;
	self->ref_count = 1;
}


static void xnoise_pl_item_finalize (XnoisePlItem* obj) {
	XnoisePlItem * self;
	self = XNOISE_PL_ITEM (obj);
	_g_hash_table_unref0 (self->priv->htable);
	self->priv->htable = NULL;
	_g_hash_table_unref0 (self->priv->htable);
	_g_free0 (self->priv->_base_path);
}


GType xnoise_pl_item_get_type (void) {
	static volatile gsize xnoise_pl_item_type_id__volatile = 0;
	if (g_once_init_enter (&xnoise_pl_item_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { xnoise_pl_value_item_init, xnoise_pl_value_item_free_value, xnoise_pl_value_item_copy_value, xnoise_pl_value_item_peek_pointer, "p", xnoise_pl_value_item_collect_value, "p", xnoise_pl_value_item_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (XnoisePlItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnoise_pl_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnoisePlItem), 0, (GInstanceInitFunc) xnoise_pl_item_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType xnoise_pl_item_type_id;
		xnoise_pl_item_type_id = g_type_register_fundamental (g_type_fundamental_next (), "XnoisePlItem", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&xnoise_pl_item_type_id__volatile, xnoise_pl_item_type_id);
	}
	return xnoise_pl_item_type_id__volatile;
}


gpointer xnoise_pl_item_ref (gpointer instance) {
	XnoisePlItem* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void xnoise_pl_item_unref (gpointer instance) {
	XnoisePlItem* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		XNOISE_PL_ITEM_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



